*if(strcmp(GenData(Solve_StructuralProblem_in_Solid),"Yes")==0)
*RealFormat "%.6g"
*IntFormat "%7i"
problem type 3d
analysis_type Static
*set var dim=3
# meassure(SI) = fac** meassure(User defined)
units_names
N-m       N    m  Pa         1.0       1.0      1.0
N-dm      N   dm  N/dm2      1.0       1.0e-1   1.0e2
N-cm      N   cm  N/cm2      1.0       1.0e-2   1.0e4
N-mm      N   mm  N/mm2      1.0       1.0e-3   1.0e6
Kp-cm     Kp  cm  Kp/cm2     1.0e1     1.0e-2   1.0e5
kN-m-MPa  kN   m  MPa        1.0e3     1.0      1.0e6
end units_names
*if(strcmp(GenData(Geometry_Units),"[m]")==0)
units_mesh m
*elseif(strcmp(GenData(Geometry_Units),"[dm]")==0)
units_mesh dm
*elseif(strcmp(GenData(Geometry_Units),"[cm]")==0)
units_mesh cm
*elseif(strcmp(GenData(Geometry_Units),"[mm]")==0)
units_mesh mm
*else
*MessageBox error: These Geometry Units are not accepted by Ramsolid
*endif
units_res *tcl(RamResultsUnits)

*tcl(ramsolid::OutputLoadcasesData)

*# combined_load_cases
*# *if(strcmp(GenData(Activate_Load_Cases),"none")==0)
*# inactive
*# *else
*# active
*# *endif
*# *for(i=1;i<=GenData(Combined_load_cases,INT);i=i+3)
*# *set var im1=i+1
*# *set var im2=i+2
*# combined_load *\
*# name=*GenData(Combined_load_cases,*i) type=*\
*# *if(GenData(Combined_load_cases,*im1,INT)==1)
*# strengths
*# *else
*# deformation
*# *endif
*# *GenData(Combined_load_cases,*im2)
*# end combined_load
*# *endfor
*# end combined_load_cases

*# GravityDirection=*GenData(Gravity_X) *GenData(Gravity_Y) *GenData(Gravity_Z)
GravityDirection=*GenData(GravityOX) *GenData(GravityOY) *GenData(GravityOZ)
*if(strcmp(Gendata(Solver_type),"Automatic")==0)
solver=Automatic
*elseif(strcmp(Gendata(Solver_type),"SkyLine")==0)
solver=SkyLine
*elseif(strcmp(Gendata(Solver_type),"Sparse")==0)
solver=SparseToni *GenData(Solver_tolerance) *GenData(Solver_tolerance_minimum) *\
*GenData(Solver_max_iterations)
*elseif(strcmp(Gendata(Solver_type),"Sparse_Toni")==0)
solver=SparseToni *GenData(Solver_tolerance) *GenData(Solver_tolerance_minimum) *\
*GenData(Solver_max_iterations)
*endif
*if(GenData(Smooth_per_material,int)==1)
DoSmoothingMaterials
*endif
NewPostProcessFormat 1
WriteAsciiResults

*#--------------------------------------------------------------------------------
*#      materials
*#--------------------------------------------------------------------------------
materials
*set var matcontrol = 0
*loop materials
*if(strcmp(MatProp(Type),"Solid")==0)
*set var matcontrol = 1
*matnum Units=*MatProp(Ram_Units) E=*MatProp(E) nu=*MatProp(nu) Weight=*MatProp(Specific_weight)
*endif
*end materials
*if(matcontrol==0)
*MessageBox error: Materials definition not found in RamSolid. Define any Solid material.
*endif
end materials

*#--------------------------------------------------------------------------------
*#      tetrahedra mesh
*#--------------------------------------------------------------------------------
*set var AreCoordsWritten(int)=0
*if(nelem(Tetrahedra))
*set elems(Tetrahedra)
mesh dimension = 3 elemtype Tetrahedra nnode = *nnode
coordinates
*loop nodes
*NodesNum *NodesCoord(1) *NodesCoord(2) *NodesCoord(3)
*end
end coordinates
*set var AreCoordsWritten=1
elements
*loop elems
*elemsnum *elemsConec *ElemsMat
*end elems
end elements
*endif
*#--------------------------------------------------------------------------------
*#      hexahedra mesh
*#--------------------------------------------------------------------------------
*if(nelem(Hexahedra))
*set elems(Hexahedra)
mesh dimension = 3 elemtype Hexahedra nnode = *nnode
coordinates
*if(AreCoordsWritten==0)
*loop nodes
*NodesNum *NodesCoord(1) *NodesCoord(2) *NodesCoord(3)
*end
*endif
*set var AreCoordsWritten=1
end coordinates
elements
*loop elems
*elemsnum *elemsConec *ElemsMat
*end elems
end elements
*endif
*#--------------------------------------------------------------------------------
*#  constraints
*#--------------------------------------------------------------------------------
constraints
*set cond Surface_Constraints
*add Cond Line_Constraints
*add Cond Point_Constraints
*loop nodes *OnlyInCond
*NodesNum *\
*for(ivar=2;ivar<=4;ivar=ivar+1)
*cond(*ivar)*\
*endfor
*format " %g %g %g "
*cond(X_Value,real)*cond(Y_Value,real)*cond(Z_Value,real)*\
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end constraints
*set Cond Surface_Elastic_Constraints *CanRepeat
*if(CondNumEntities(int)>0)
elem_constraints
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*ElemsNum *iface *\
*for(ivar=2;ivar<=4;ivar=ivar+1)
*if(strcmp(cond(*ivar),"1")==0)
2*\
*else
0*\
*endif
*endfor
*format " %g %g %g"
*cond(X_Value,real)*cond(Y_Value,real)*cond(Z_Value,real)*\
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end elem_constraints
*endif
*#--------------------------------------------------------------------------------
*#  loads
*#--------------------------------------------------------------------------------
*loop intervals
*Set Cond Punctual_Load
*if(CondNumEntities(int)>0)
nodal_point_loads
*loop nodes *OnlyInCond
*NodesNum *cond(X_Force) *cond(Y_Force) *cond(Z_Force) *\
Units=*cond(Units)
*end
end nodal_point_loads
*endif

*Set Cond Global_Pressure_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
global_pressure_loads
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*ElemsNum *iface *cond(X_Pressure) *cond(Y_Pressure) *cond(Z_Pressure) *\
Units=*cond(Units)
*end
end global_pressure_loads
*endif
*Set Cond Global_Projected_Pressure_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)        
global_projected_pressure_loads
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*elemsnum *iface *cond(X_Pressure) *cond(Y_Pressure) *cond(Z_Pressure) *\
Units=*cond(Units)
*end
end global_projected_Pressure_loads
*endif
*Set Cond Local_Pressure_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
local_pressure_loads
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*elemsnum *iface 0.0 0.0 *cond(Normal_inwards) *\
Units=*cond(Units)
*end
end local_pressure_loads
*endif
*Set Cond Self_weight_solid
*if(CondNumEntities(int)>0)
self_weight_loads
*loop elems *OnlyInCond
*elemsnum
*end
end self_weight_loads
*endif
*Set Cond Solid_triangular_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
triangular_global_loads
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*elemsnum *iface *cond(X_pressure_1) *cond(Y_pressure_1) *\
*cond(Z_pressure_1) *cond(X_pressure_2) *cond(Y_pressure_2) *cond(Z_pressure_2) *\
p *cond(X_point_1) *cond(Y_point_1) *cond(Z_point_1) *cond(X_point_2) *cond(Y_point_2) *\
*cond(Z_point_2) *\
Units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end triangular_global_loads
*endif
*Set Cond Solid_hydrostatic_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
hydrostatic_loads
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*elemsnum *iface *cond(Reference_coordinate) *cond(Self_weight_water) *\
Units=*cond(Units)
*end
end hydrostatic_loads
*endif
*Set Cond Temperature *elems
*if(CondNumEntities(int)>0)
temperature_loads
*loop elems *OnlyInCond
*elemsnum *cond(alpha) *cond(Delta_T)
*end
end temperature_loads
*endif
*#--------------------------------------------------------------------------------
*#    Tdyn_Strain
*#--------------------------------------------------------------------------------
*tcl(ramsolid::OutputTdyn_Strain)
*end intervals
*#--------------------------------------------------------------------------------
*#    Detailed results
*#--------------------------------------------------------------------------------
*set cond Detailed_results
*if(CondNumEntities>0)
detailed_results
*loop nodes *OnlyInCond
*NodesNum *cond(Id)
*end
end detailed_results
*endif
*endif
